"use strict";

require("core-js/modules/es7.symbol.async-iterator");

require("core-js/modules/es6.symbol");

require("core-js/modules/es6.object.seal");

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});

var ImmutableBuilder_1 = require("../map/ImmutableBuilder");

function valid(key) {
  if (typeof key !== 'string') {
    throw new Error("Resolved key must be a string, actual: value - ".concat(key, " type - ").concat(_typeof(key)));
  }

  return key;
}

exports.valid = valid;

exports.finalizeMap = function (map) {
  if (map instanceof ImmutableBuilder_1.ImmutableBuilder) {
    return map.buildMap();
  }

  return map;
};

exports.finalizeObject = function (map) {
  if (Object.getOwnPropertyDescriptor(map, 'immutable')) {
    return Object.seal(map);
  }

  return map;
};

exports.isLastElement = function (array, index) {
  return array.length - 1 === index;
}; // @ts-ignore


function onDuplacateDefaultFunction(v1, v2, key) {
  throw new Error("Key: \"".concat(key, "\" has duplicates"));
}

exports.onDuplacateDefaultFunction = onDuplacateDefaultFunction;