"use strict";

require("core-js/modules/es6.object.freeze");

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

Object.defineProperty(exports, "__esModule", {
  value: true
});

var JMap_1 = require("./JMap");

var ImmutableMap_1 = require("./ImmutableMap");

var ImmutableBuilder =
/*#__PURE__*/
function () {
  function ImmutableBuilder() {
    _classCallCheck(this, ImmutableBuilder);

    this.map = new JMap_1.JMap();
  }

  _createClass(ImmutableBuilder, [{
    key: "keys",
    value: function keys() {
      throw new Error('Method not implemented.');
    }
  }, {
    key: "values",
    value: function values() {
      throw new Error('Method not implemented.');
    }
  }, {
    key: "containsKey",
    value: function containsKey(key) {
      return this.map.containsKey(key);
    }
  }, {
    key: "containsValue",
    value: function containsValue() {
      throw new Error('Method not implemented.');
    }
  }, {
    key: "entries",
    value: function entries() {
      throw new Error('Method not implemented.');
    }
  }, {
    key: "size",
    value: function size() {
      throw new Error('Method not implemented.');
    }
  }, {
    key: "toObject",
    value: function toObject() {
      throw new Error('Method not implemented.');
    }
  }, {
    key: "put",
    value: function put(key, value) {
      var prevValue = this.map.get(key);
      this.map.put(key, value);
      return prevValue;
    }
  }, {
    key: "get",
    value: function get(key) {
      return this.map.get(key);
    }
  }, {
    key: "buildMap",
    value: function buildMap() {
      return new ImmutableMap_1.ImmutableMap(this.map.toObject());
    }
  }, {
    key: "buildObject",
    value: function buildObject() {
      return Object.freeze(this.map.toObject());
    }
  }]);

  return ImmutableBuilder;
}();

exports.ImmutableBuilder = ImmutableBuilder;