import { MethodMap, Entry } from './MethodMap';
export declare class JMap<T> implements MethodMap<T> {
    private storage;
    constructor(obj?: {
        [keyof: string]: T;
    });
    put(key: string, value: T): void;
    get(key: string): T | undefined;
    keys(): string[];
    values(): T[];
    containsKey(key: string): boolean;
    containsValue(value: T): boolean;
    entries(): Entry<T>[];
    size(): number;
    toObject(): {
        [keyof: string]: T;
    };
}
