"use strict";

require("core-js/modules/web.dom.iterable");

require("core-js/modules/es6.array.iterator");

require("core-js/modules/es6.object.keys");

require("core-js/modules/es6.object.assign");

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

Object.defineProperty(exports, "__esModule", {
  value: true
});

var JMap =
/*#__PURE__*/
function () {
  function JMap(obj) {
    _classCallCheck(this, JMap);

    this.storage = {};

    if (obj) {
      this.storage = Object.assign({}, obj);
    }
  }

  _createClass(JMap, [{
    key: "put",
    value: function put(key, value) {
      this.storage[key] = value;
    }
  }, {
    key: "get",
    value: function get(key) {
      return this.storage[key];
    }
  }, {
    key: "keys",
    value: function keys() {
      return Object.keys(this.storage);
    }
  }, {
    key: "values",
    value: function values() {
      var _this = this;

      return Object.keys(this.storage).map(function (key) {
        return _this.storage[key];
      });
    }
  }, {
    key: "containsKey",
    value: function containsKey(key) {
      return Object.prototype.hasOwnProperty.call(this.storage, key);
    }
  }, {
    key: "containsValue",
    value: function containsValue(value) {
      return this.values().some(function (v) {
        return v === value;
      });
    }
  }, {
    key: "entries",
    value: function entries() {
      var _this2 = this;

      return this.keys().map(function (k) {
        return {
          key: k,
          value: _this2.storage[k]
        };
      });
    }
  }, {
    key: "size",
    value: function size() {
      return this.keys().length;
    }
  }, {
    key: "toObject",
    value: function toObject() {
      return this.storage;
    }
  }]);

  return JMap;
}();

exports.JMap = JMap;