import { JMap } from './JMap';
import { ImmutableBuilder } from './ImmutableBuilder';
import { MethodMap } from './MethodMap';
export declare class ImmutableMap<T> extends JMap<T> implements MethodMap<T> {
    static builder<T>(): ImmutableBuilder<T>;
    constructor(obj: {
        [keyof: string]: T;
    });
    put(): never;
    toObject(): Readonly<{
        [keyof: string]: T;
    }>;
}
